<?php

namespace Targetbay\Tracking\Block\Adroll;

use Magento\Framework\View\Element\Template\Context;
use Magento\Framework\View\Element\Template;
use Magento\Sales\Model\Order;
use Magento\Sales\Model\OrderFactory;
use Magento\Checkout\Model\Session;


/**
 * Class Async
 *
 * @package Springbot\Main\Block
 */
class EnhancedPixel extends \Magento\Framework\View\Element\Template
{

    private $order;
    private $orderFactory;
    private $session;
    public $trackingHelper;


    /**
     * EnhancedPixel constructor.
     *
     * @param Context            $context
     * @param OrderFactory       $orderFactory
     * @param Session            $session
     */
    public function __construct(
        Context $context,
        OrderFactory $orderFactory,
        Session $session,
        \Targetbay\Tracking\Helper\Data $trackingHelper
    ) {
    
        $this->orderFactory = $orderFactory;
        $this->session = $session;
        $this -> trackingHelper = $trackingHelper;
        parent::__construct($context);

    }


    /**
     * @return float
     */
    public function getConversionValueInDollars()
    {
        $order = $this->getLastOrder();
        return $order->getGrandTotal();
    }

    public function getOrder($id)
    {
        return $this->orderRepository->get($id);
    }

    /**
     * @return string
     */
    public function getIncrementId()
    {
        return $this->getLastOrder()->getIncrementId();
    }

    /**
     * @return Order
     */
    public function getLastOrder()
    {
        if (!isset($this->order)) {
            $this->order = $this->orderFactory->create()->load($this->getOrderId());
        }
        return $this->order;
    }

    /**
     * @return int
     */
    public function getOrderId()
    {
        $lastOrder = $this->session->getLastRealOrder();
        /* @var Order $lastOrder */
        return $lastOrder->getId();
    }

    public function getTbAdRollSettings(){
        return $this -> trackingHelper -> getAdRollSettings();
    }


}
