<?php

namespace Targetbay\Tracking\Block\Product;

class Inventory extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Targetbay\Tracking\Helper\Data
     */
    protected $trackingHelper;

    /**
     * @var \Targetbay\Tracking\Helper\Inventory
     */
    protected $trackingInventoryHelper;

    /**
     * @var \Magento\Framework\Registry
     */
    protected $registry;

    /**
     * @var \Magento\Framework\ObjectManagerInterface
     */
    protected $objectManager;

    /**
     * @param \Targetbay\Tracking\Helper\Data $trackingHelper
     * @param \Targetbay\Tracking\Helper\Inventory $trackingInventoryHelper
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\ObjectManagerInterface $objectManager
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        \Targetbay\Tracking\Helper\Inventory $trackingInventoryHelper,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\ObjectManagerInterface $objectManager
    ) {
        parent::__construct($context);
        $this->trackingHelper = $trackingHelper;
        $this->trackingInventoryHelper = $trackingInventoryHelper;
        $this->registry = $registry;
        $this->objectManager = $objectManager;
    }

    public function getProduct()
    {
        return $this->registry->registry('current_product');
    }

    public function getStockItem($productId)
    {
        $productStockObj = $this->objectManager->get('Magento\CatalogInventory\Api\StockRegistryInterface')
                        ->getStockItem($productId);
        return $productStockObj;
    }

    public function getBackOrderStatus()
    {
        $html = '';
        if ($this->trackingInventoryHelper->getInventryStatus() == 1) {
            $html .= '<div id="tb-backinstock"></div>';
        }
        return $html;
    }
}
