<?php
namespace Targetbay\Tracking\Block\Product;

class Review extends \Magento\Framework\View\Element\Template {
	public $trackingHelper;
	public $registry;
	protected $_imageBuilder;

	public function __construct(\Magento\Framework\View\Element\Template\Context $context, \Targetbay\Tracking\Helper\Data $trackingHelper, \Magento\Catalog\Block\Product\Context $productContext) {
		parent::__construct($context);
		$this -> trackingHelper = $trackingHelper;
		$this -> registry = $productContext -> getRegistry();
		$this -> _imageBuilder = $productContext -> getImageBuilder();
	}

	public function getProduct() {
		return $this -> registry -> registry('current_product');
	}

	public function getProductReviews() {
		return $this -> trackingHelper -> getRichSnippets();
	}

	public function getSnippetType() {
		return $this -> trackingHelper -> getRichsnippetType();
	}

	public function getCurrencyCode() {
		return $this -> _storeManager -> getStore() -> getCurrentCurrencyCode();
	}

	public function getImage($product, $imageId, $attributes = []) {
		return $this -> _imageBuilder -> setProduct($product) -> setImageId($imageId) -> setAttributes($attributes) -> create();
	}

	public function getTbAdRollSettings(){
		return $this -> trackingHelper -> getAdRollSettings();
	}

}
