<?php

namespace Targetbay\Tracking\Block;

class Recommended extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Targetbay\Tracking\Helper\Data
     */
    protected $trackingHelper;

    /**
     * @var \Magento\Cms\Model\Page
     */
    protected $cmsPage;

    /**
     * @param \Targetbay\Tracking\Helper\Data $trackingHelper
     * @param \Magento\Cms\Model\Page $cmsPage
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        \Magento\Cms\Model\Page $cmsPage
    ) {
        parent::__construct($context);
        $this->_trackingHelper = $trackingHelper;
        $this->_cmsPage = $cmsPage;
        if ($this->_trackingHelper->trackingEnabled()) {
            $this->setTemplate('Targetbay_Tracking::recommended.phtml');
        }
    }

    public function getMostReviewedPlaceholder()
    {
        $routeName = $this->getRequest()->getRouteName();
        $identifier = $this->_cmsPage->getIdentifier();

        $htmlTag = '';

        if ($routeName === 'cms' && ($identifier === 'home' || $identifier === 'homepage')) {
            $htmlTag = '<div id="tb_most_reviewed"></div>';
        }

        return $htmlTag;
    }
}
