<?php
/*
 * @author TargetBay
 * @copyright - Sathishkumar Mariappan <sathishkumar.m@innoppl.com>
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Helper;

/**
 * Class Data
 *
 * Custom helper class
 *
 * @package Targetbay\Tracking\Helper
 */
class Postdata extends \Magento\Framework\App\Helper\AbstractHelper {

	public function __construct(\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig, \Targetbay\Tracking\Helper\Store $trackingStoreHelper) {
		$this -> _scopeConfig = $scopeConfig;
		$this -> _trackingStoreHelper = $trackingStoreHelper;
	}

	/**
	 * Push the page info using Varien_Http_Client
	 *
	 * @param $url
	 * @param $jsonData
	 *
	 * @return string
	 */
	public function postPageInfo($url, $jsonData) {
		$response = '';
		$client = new \Zend_Http_Client();
		$client -> setUri((string)$url);
		$client -> setConfig(['maxredirects' => 0, 'timeout' => 5]);
		$client -> setMethod('POST');
		$client -> setRawData(utf8_encode($jsonData));

		$this -> _trackingStoreHelper -> debug('EndpointUrl ===>' . $url);
		$this -> _trackingStoreHelper -> debug('Request ===>' . $jsonData);
		try {
			$client -> request() -> getBody();
		} catch (\Exception $e) {
			$this -> _trackingStoreHelper -> debug($e);
		}
		// return $response;
	}

	/**
	 * API Calls
	 *
	 * @param $data
	 * @param $type
	 */
	public function pushPages($data, $type) {
        
		$tbConfig = $this -> _trackingStoreHelper -> getTbConfig();

        // check the token settings should not be empty.
        if($tbConfig['hostname'] && $tbConfig['api_token'] && $tbConfig['api_index'] !== ''){
            $endPointUrl = $tbConfig['hostname'] . $type . '?api_token=' . $tbConfig['api_token'];
            $data['index_name'] = $tbConfig['api_index'];
            try {
                $this -> postPageInfo($endPointUrl, json_encode($data));
            } catch (\Exception $e) {
                $this -> _trackingStoreHelper -> debug(" '$type' ERROR:" . $e -> getMessage());
            }
        }else{
            $this -> _trackingStoreHelper -> debug(" hostname / api_token / api_index is empty.");
        }
		
	}

}
