<?php
namespace Targetbay\Tracking\Helper;

class Store extends \Magento\Framework\App\Helper\AbstractHelper {

	public function __construct(\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig, \Magento\Store\Model\StoreManagerInterface $storeManager) {
		$this -> scopeConfig = $scopeConfig;
		$this -> storeManager = $storeManager;
	}

	public function getTbConfig() {
		$tb['hostname'] = $this -> scopeConfig -> getValue('targetbay_tracking/tracking_groups/hostname', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $this -> storeManager -> getStore() -> getStoreId());

		$tb['api_token'] = $this -> scopeConfig -> getValue('targetbay_tracking/tracking_groups/api_token', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $this -> storeManager -> getStore() -> getStoreId());

		$tb['api_status'] = $this -> scopeConfig -> getValue('targetbay_tracking/tracking_groups/api_status', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $this -> storeManager -> getStore() -> getStoreId());

		$tb['api_index'] = $this -> scopeConfig -> getValue('targetbay_tracking/tracking_groups/api_index', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $this -> storeManager -> getStore() -> getStoreId());
		
		return $tb;
	}

	public function debug($mess) {
		$fileName = $this -> getLogFileName();
		if ($this -> logEnabled()) {
			$writer = new \Zend\Log\Writer\Stream(BP . '/var/log/' . $fileName);
			$logger = new \Zend\Log\Logger();
			$logger -> addWriter($writer);
			$logger -> info($mess);
		}
	}

	public function getLogFileName() {
		return $this -> scopeConfig -> getValue('targetbay_tracking/tracking_groups/debug_file', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $this -> storeManager -> getStore() -> getStoreId());
	}

	public function logEnabled() {
		return $this -> scopeConfig -> getValue('targetbay_tracking/tracking_groups/debug', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $this -> storeManager -> getStore() -> getStoreId());
	}

}
