<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\CategoryRepoInterface;

/**
 * Defines the implementation class of the CategoryRepoInterface.
 */
class CategoryRepo implements CategoryRepoInterface
{
    /**
     * @var \Magento\Catalog\Model\ResourceModel\Category\CollectionFactory
     */
    protected $categoryCollection;

    protected $request;

    /**
     * @param \Magento\Catalog\Model\ResourceModel\Category\CollectionFactory
     */
    public function __construct(
        \Magento\Catalog\Model\ResourceModel\Category\CollectionFactory $categoryCollection,
        \Magento\Framework\App\RequestInterface $request
    ) {
        $this->_categoryCollection = $categoryCollection;
        $this->request = $request;
    }
    /**
     * Get the list of categories
     *
     * @return CategoryRepoInterface[]
     */
    public function getList(\Magento\Framework\Api\SearchCriteria $searchCriteria)
    {
        $storeId = $this->request->getParam('store_id');
        $collection = $this->_categoryCollection->create();
        $collection->addAttributeToSelect('*');
        $collection->setStoreId($storeId);

        $collection->setCurPage($searchCriteria->getCurrentPage());
        $collection->setPageSize($searchCriteria->getPageSize());


        $category = $collection->load()->toArray();

        return $category;
    }
}
