<?php

/**
 * @author Targetbay
 * @copyright Copyright (c) 2016 TargetBay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model\Customer;

class Customer extends \Magento\Customer\Model\Customer
{
   public function sendNewAccountEmail($type = 'registered', $backUrl = '', $storeId = '0')
    {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $trackingHelper = $objectManager->create('Targetbay\Tracking\Helper\Data');
        try {
            $emailStatus = $trackingHelper->getEmailStatus();

            if ($emailStatus == 1) {
                return false;
            }
        } catch(\Exception $e) {
            $e->getMessage();
        }

        $types = $this->getTemplateTypes();

        if (!isset($types[$type])) {
            throw new \Magento\Framework\Exception\LocalizedException(
                __('Please correct the transactional account email type.')
            );
        }

        if (!$storeId) {
            $storeId = $this->_getWebsiteStoreId($this->getSendemailStoreId());
        }

        $this->_sendEmailTemplate(
            $types[$type],
            self::XML_PATH_REGISTER_EMAIL_IDENTITY,
            ['customer' => $this, 'back_url' => $backUrl, 'store' => $this->getStore()],
            $storeId
        );
        return $this;
    }
}

