<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\SubscriberRepoInterface;

/**
 * Defines the implementation class of the SubscriberRepoInterface.
 */
class SubscriberRepo implements SubscriberRepoInterface
{
    /**
     * @var \Magento\Newsletter\Model\ResourceModel\Subscriber\CollectionFactory
     */
    protected $subscriberCollectionFactory;

    /**
     * @param \Magento\Newsletter\Model\ResourceModel\Subscriber\CollectionFactory
     */
    public function __construct(
        \Magento\Newsletter\Model\SubscriberFactory $subscriberCollectionFactory
    ) {
        $this->_subscriberCollectionFactory  = $subscriberCollectionFactory;
    }

    /**
     * Get the list of subscribers
     *
     * @return SubscriberRepoInterface[]
     */
    public function getList(\Magento\Framework\Api\SearchCriteria $searchCriteria)
    {
        $collection = $this->_subscriberCollectionFactory->create()->addFieldToSelect('*');

        $collection->setCurPage($searchCriteria->getCurrentPage());
        $collection->setPageSize($searchCriteria->getPageSize());

        $customer = $collection->load()->toArray();

        return $customer;
    }
}
