<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\TbreviewcountInterface;

/**
 * Defines the implementation class of the Tbreviewcount.
 */
class Tbreviewcount implements TbreviewcountInterface
{

    /**
     * @var \Magento\Framework\App\RequestInterface $request
     */
    protected $request;

    /**
     * @var \Targetbay\Tracking\Helper\Data $trackingHelper
     */
    protected $trackingHelper;

    /**
     * @var \Magento\Framework\App\CacheInterface
     */
    public $cacheType;

    public function __construct(
        \Magento\Framework\App\RequestInterface $request,
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        \Magento\Framework\App\CacheInterface $cacheType
    ) {
        $this->_request = $request;
        $this->_trackingHelper = $trackingHelper;
        $this->_cacheType = $cacheType;
    }

    /**
     * Get targetbay review count
     *
     * @return boolean
     */
    public function tbreviewcount()
    {
        $pageReference = $this->_request->getParam('page_identifier') ? $this->_request->getParam('page_identifier') : '';

        $reviewCount = $this->_request->getParam('review_count') ? $this->_request->getParam('review_count') : '';

        $product = $this->_request->getParam('product_id') ? $this->_request->getParam('product_id') : '';
        $prodcutExplode = explode('?', $product);
        $productId = $prodcutExplode[0];
        $cachesiteTbCountId = 'site_tbreview_count';
        $cacheTbCountId = 'product_tbreview_count';
        $cacheqTbCountId = 'qa_tbreview_count';
        $cacheKey = 'block_html';

        if (!empty($pageReference) && $reviewCount !== '') {
            try {
                switch ($pageReference) {
                    case \Targetbay\Tracking\Helper\Data::RATINGS_STATS:
                    if ((string) $reviewCount) {
                        if ($productId == '' || $productId == 0) {
                            $this->_cacheType->remove($cachesiteTbCountId);
                        } elseif ($productId !== '' || $productId > 0) {
                            $cacheDataId = $cacheTbCountId . '_' . $productId;
                            $this->_cacheType->remove($cacheDataId);
                            $this -> _cacheType -> remove('product_tbreview_response_' . $productId);
                        }
                    } else {
                        if ($productId == '' || $productId == 0) {
                            $this->_cacheType->remove($cachesiteTbCountId);
                            $this->_cacheType->save(serialize($reviewCount), $cachesiteTbCountId, [$cacheKey]);
                        } elseif ($productId !== '' || $productId > 0) {
                            $cacheDataId = $cacheTbCountId . '_' . $productId;
                            $this->_cacheType->remove($cacheTbCountId);
                            $this -> _cacheType -> remove('product_tbreview_response_' . $productId);
                            $this->_cacheType->save(serialize($reviewCount), $cacheDataId, [$cacheKey]);
                        }
                    }
                    break;
                    case \Targetbay\Tracking\Helper\Data::QUESTION_STATS:
                        if ((string) $reviewCount) {
                            $cacheDataId = $cacheqTbCountId . '_' . $productId;
                            $this->_cacheType->remove($cacheDataId);
                        } else {
                            $cacheDataId = $cacheqTbCountId . '_' . $productId;
                            $this->_cacheType->save(serialize($reviewCount), $cacheDataId, [$cacheKey]);
                        }
                    break;
                }
            } catch (\Exception $e) {
                $this->_trackingHelper->debug('Error :' . $e);
            }
            return true;
        }
    }
}
