<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\TotalCategoryInterface;

/**
 * Defines the implementation class of the TotalCategory.
 */
class TotalCategory implements TotalCategoryInterface
{
    /**
     * @var \Magento\Catalog\Model\CategoryFactory
     */
    protected $categoryFactory;

    protected $request;

    /**
     * @param \Magento\Catalog\Model\CategoryFactory $categoryFactory
     */
    public function __construct(
        \Magento\Catalog\Model\CategoryFactory $categoryFactory,
        \Magento\Framework\App\RequestInterface $request
    ) {
        $this->_categoryFactory = $categoryFactory;
        $this->request = $request;
    }

    /**
     * Get the Total Category
     *
     * @return totals
     */
    public function totalcategorycount()
    {
        $storeId = $this->request->getParam('store_id');
        $collection = $this->_categoryFactory->create()->getCollection();
        $collection->setStoreId($storeId);

        $totals = [
            'total_categories' => $collection->getSize()
        ];

        return json_encode($totals);
    }
}
