<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\TotalCustomerInterface;

/**
 * Defines the implementation class of the TotalCustomer.
 */
class TotalCustomer implements TotalCustomerInterface
{
    /**
     * @var \Magento\Customer\Model\CustomerFactory
     */
    protected $customerFactory;

    protected $request;

    /**
     * @param \Magento\Customer\Model\CustomerFactory
     */
    public function __construct(
        \Magento\Customer\Model\CustomerFactory $customerFactory,
        \Magento\Framework\App\RequestInterface $request
    ) {
        $this->_customerFactory = $customerFactory;
        $this->request = $request;
    }

    /**
     * Get the Total Customer
     *
     * @return totals
     */
    public function totalcustomercount()
    {
        $storeId = $this->request->getParam('store_id');
        $collection = $this->_customerFactory->create()->getCollection();
        $collection->addFieldToFilter('store_id', $storeId);

        $totals = [
            'total_customer' => $collection->getSize()
        ];

        return json_encode($totals);
    }
}
