<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\TotalOrderInterface;

/**
 * Defines the implementation class of the TotalOrder.
 */
class TotalOrder implements TotalOrderInterface
{
    /**
     * @var \Magento\Sales\Model\OrderFactory
     */
    protected $orderFactory;

    protected $request;

    /**
     * @param \Magento\Sales\Model\OrderFactory
     */
    public function __construct(
        \Magento\Sales\Model\OrderFactory $orderFactory,
        \Magento\Framework\App\RequestInterface $request
    ) {
        $this->_orderFactory  = $orderFactory;
        $this->request = $request;
    }

    /**
     * Get the total count of order
     *
     * @return totals
     */
    public function totalordercount()
    {
        $storeId = $this->request->getParam('store_id');

        // return $storeId;
        $collection = $this->_orderFactory->create()->getCollection();
        $collection->addFieldToFilter('store_id', $storeId);

        $totals = [
            'total_orders' => $collection->getSize()
        ];

        return json_encode($totals);
    }
}
