<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\TotalProductInterface;

/**
 * Defines the implementation class of the TotalProduct.
 */
class TotalProduct implements TotalProductInterface
{
    /**
     * @var \Magento\Catalog\Model\ProductFactory
     */
    protected $productFactory;

    protected $request;

    /**
     * @param \Magento\Catalog\Model\ProductFactory
     */
    public function __construct(
        \Magento\Catalog\Model\ProductFactory $productFactory,
        \Magento\Framework\App\RequestInterface $request
    ) {
        $this->_productFactory = $productFactory;
        $this->request = $request;
    }

    /**
     * Get the Total Products
     *
     * @return totals
     */
    public function totalproductcount()
    {
        $storeId = $this->request->getParam('store_id');
        $collection = $this->_productFactory->create()->getCollection();
        $collection->addStoreFilter($storeId);

        $totals = [
            'total_products' => $collection->getSize()
        ];

        return json_encode($totals);
    }
}
