<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\TotalReviewInterface;

/**
 * Defines the implementation class of the TotalReview.
 */
class TotalReview implements TotalReviewInterface
{
    /**
     * @var \Magento\Newsletter\Model\SubscriberFactory
     */
    protected $subscriberFactory;

    /**
     * @param \Magento\Review\Model\ReviewFactory
     */
    public function __construct(
        \Magento\Review\Model\ReviewFactory $reviewFactory
    ) {
        $this->_reviewFactory  = $reviewFactory;
    }

    /**
     * Get the Total Review
     *
     * @return totals
     */
    public function totalreviewcount()
    {
        $collection = $this->_reviewFactory->create()->getCollection();

        $totals = [
            'total_review' => $collection->getSize()
        ];

        return json_encode($totals);
    }
}
