<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\TotalSubscriberInterface;

/**
 * Defines the implementation class of the TotalSubscriber.
 */
class TotalSubscriber implements TotalSubscriberInterface
{
    /**
     * @var \Magento\Newsletter\Model\SubscriberFactory
     */
    protected $subscriberFactory;

    /**
     * @param \Magento\Newsletter\Model\SubscriberFactory
     */
    public function __construct(
        \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory
    ) {
        $this->_subscriberFactory  = $subscriberFactory;
    }

    /**
     * Get the Total Subscriber
     *
     * @return totals
     */
    public function totalsubscribercount()
    {
        $collection = $this->_subscriberFactory->create()->getCollection();

        $totals = [
            'total_subscriber' => $collection->getSize()
        ];

        return json_encode($totals);
    }
}
