<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\TotalWishlistInterface;

/**
 * Defines the implementation class of the TotalWishlist.
 */
class TotalWishlist implements TotalWishlistInterface
{
    /**
     * @var \Magento\Framework\App\ObjectManager
     */
    protected $objectManager;

    public function __construct(
        \Magento\Framework\App\ObjectManager $objectManager
    ) {
        $this->_objectManager = $objectManager;
    }

    /**
     * Get the Total Wishlist
     *
     * @return totals
     */
    public function totalwishlistcount()
    {
        $wishlistCollection = $this->_objectManager->create('Magento\Wishlist\Model\Wishlist')->getCollection();
        $i = 0;
        $count = '';

        foreach ($wishlistCollection as $id => $wishlist) {
            $wishlistInfo = $this->_objectManager->create('Magento\Wishlist\Model\Wishlist')
                ->loadByCustomerId($wishlist->getCustomerId());
            $wishlistItemCollection = $wishlistInfo->setStoreId(1)->getItemCollection();
            if ($wishlistItemCollection->getSize() > 0) {
                $count = $i + 1;
                $i++;
            }
        }

        $totals = [
            'total_wishlist' => $count
        ];

        return json_encode($totals);
    }
}
