<?php

/**
 * @author Targetbay Team
 * @copyright Copyright (c) 2016 Targetbay
 * @package Targetbay_Tracking
 */

namespace Targetbay\Tracking\Model;

use Targetbay\Tracking\Api\UpdateRewardPointsInterface;

/**
 * Defines the implementaiton class of the UpdateRewardPoints.
 */
class UpdateRewardPoints implements UpdateRewardPointsInterface
{
    const REWARD_ACTION_REVIEW = 6;

    /**
     * @var \Magento\Framework\App\RequestInterface
     */
    protected $request;

    /**
     * @var \Targetbay\Tracking\Helper\Data
     */
    protected $trackingHelper;

    /**
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    protected $storeManager;

    /**
     * @var \Magento\Framework\ObjectManagerInterface
     */
    public $objectManager;

    /**
     * Reward helper
     *
     * @var \Magento\Reward\Helper\Data
     */
    //public $rewardData;

    public function __construct(
        \Magento\Framework\App\RequestInterface $request,
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\ObjectManagerInterface $objectManager
        //\Magento\Reward\Helper\Data $rewardData
    ) {
        $this->_request = $request;
        $this->_trackingHelper = $trackingHelper;
        $this->_storeManager = $storeManager;
        $this->_objectManager = $objectManager;
        //$this->_rewardData = $rewardData;
    }

    /**
     * Update reward points for customer
     *
     * @return boolean
     */
    public function save()
    {
        $customerId = $this->_request->getParam('customer_id');
        $customerData = $this->_objectManager->create('\Magento\Customer\Model\Customer')
            ->load($customerId);
        $storeId = $this->getStoreId();
        $websiteId = $this->_storeManager->getStore($storeId)->getWebsiteId();
        /*if (!$this->_rewardData->isEnabledOnFront($websiteId)) {
            return false;
        }

        $rewardFactory = $objectManager->create('Magento\Reward\Model\Reward');

        if (null !== $customerData) {
            $rewardFactory->setCustomerId($customerId)
                ->setStore($storeId)
                ->setAction(self::REWARD_ACTION_REVIEW)
                ->updateRewardPoints();
            return true;
        }*/

        return false;
    }

    /**
     * Get store identifier
     *
     * @return  int
     */
    public function getStoreId()
    {
        return $this->_storeManager->getStore()->getId();
    }
}
