<?php

namespace Targetbay\Tracking\Observer;

use Magento\Framework\Event\ObserverInterface;

class DeleteCartEventHandler implements ObserverInterface
{
    const REMOVECART = 'remove-to-cart';

    public $_trackingHelper;
    public $_postdataHelper;

    public function __construct(
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        \Targetbay\Tracking\Helper\Postdata $postdataHelper
    ) {
        $this->_trackingHelper  = $trackingHelper;
        $this->_postdataHelper  = $postdataHelper;
    }

    /**
     * Capture the remove cart item data
     *
     * @param \Magento\Framework\Event\Observer $observer
     *
     * @return void
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        if (!$this->_trackingHelper->canTrackPages(self::REMOVECART)) {
            return false;
        }

        try {
            $item = $observer->getEvent()->getData('quote_item');
            $data = array_merge($this->_trackingHelper->getCartInfo(), $this->_trackingHelper->getItemInfo($item));
            $this->_postdataHelper->pushPages($data, self::REMOVECART);
        }catch (\Exception $e) {
            $this->_trackingHelper->debug("Delete cart ERROR:" . $e->getMessage());
        }
        
    }
}
