<?php

namespace Targetbay\Tracking\Observer;

use Magento\Framework\Event\ObserverInterface;

class OrderStatusEventHandler implements ObserverInterface
{
    
    const ORDER_STATUS = 'order-status';

    public $_trackingHelper;
    protected $_postdataHelper;

    public function __construct(
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        \Targetbay\Tracking\Helper\Postdata $postdataHelper
    ) {
        $this->_trackingHelper = $trackingHelper;
        $this->_postdataHelper  = $postdataHelper;
    }

    /**
     * Order data
     *
     * @param \Magento\Framework\Event\Observer $observer
     *
     * @return void|boolean
     */

    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        if (!$this->_trackingHelper->canTrackPages(self::ORDER_STATUS)) {
            return false;
        }
        try {
            $order = $observer->getEvent()->getOrder();
            $data ['order_id'] = $order->getId();
            $data ['status'] = $order->getStatus();
            $this->_postdataHelper->pushPages($data, self::ORDER_STATUS);
        } catch (\Exception $e) {
            $this->_trackingHelper->debug("Order status ERROR:" . $e->getMessage());
        }
    }
}
