<?php

namespace Targetbay\Tracking\Observer;

use Magento\Checkout\Model\Session as CheckoutSession;
use Magento\Customer\Model\Session as CustomerSession;
use Magento\Framework\App\RequestInterface as RequestInterface;
use Magento\Framework\Event\ObserverInterface;

class SaveCustomerAddressDataEventHandler implements ObserverInterface
{
    const CUSTOMER_ADDRESS = 'change-user-address';

    protected $_trackingHelper;
    protected $_request;
    protected $_postdataHelper;

    public function __construct(
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        RequestInterface $request,
        \Targetbay\Tracking\Helper\Postdata $postdataHelper
    ) {
        $this->_trackingHelper = $trackingHelper;
        $this->_request = $request;
        $this->_postdataHelper  = $postdataHelper;
    }

    /**
     * Update account info observer
     *
     * @param \Magento\Framework\Event\Observer $observer
     *
     * @return void|bool
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        if (!$this->_trackingHelper->canTrackPages(self::CUSTOMER_ADDRESS)) {
            return false;
        }

        try{
            $addressId = $this->_request->getParam('id');
            $data = $this->_trackingHelper->getCustomerAddressData($addressId);
            $this->_postdataHelper->pushPages($data, self::CUSTOMER_ADDRESS);
        }catch (\Exception $e) {
            $this->_trackingHelper->debug("save customer address ERROR:" . $e->getMessage());
        }
    }
}
