<?php

namespace Targetbay\Tracking\Observer;

use Magento\Framework\Event\ObserverInterface;

class UserLogoutEventHandler implements ObserverInterface
{
    const LOGOUT = 'logout';

    protected $_trackingHelper;
    protected $_postdataHelper;

    public function __construct(
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        \Targetbay\Tracking\Helper\Postdata $postdataHelper
    ) {
        $this->_trackingHelper = $trackingHelper;
        $this->_postdataHelper  = $postdataHelper;
    }

    /**
     * @param \Magento\Framework\Event\Observer $observer
     * @return bool
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        if (!$this->_trackingHelper->canTrackPages(self::LOGOUT)) {
            return false;
        }

        try {
            
            $data = $this->_trackingHelper->getCustomerData($observer->getCustomer(), self::LOGOUT);
            $this->_postdataHelper->pushPages($data, self::LOGOUT);
            // Remove all Cookies
            $this->_trackingHelper->removeCookies();
        } catch (\Exception $e) {
            $this->_trackingHelper->debug("Logout ERROR:" . $e->getMessage());
        }
    }
}
