<?php

namespace Targetbay\Tracking\Observer;

use Magento\Framework\Event\ObserverInterface;

class UserRegisterEventHandler implements ObserverInterface
{
    const CREATE_ACCOUNT = 'create-account';

    protected $_trackingHelper;
    protected $_postdataHelper;

    public function __construct(
        \Targetbay\Tracking\Helper\Data $trackingHelper,
        \Targetbay\Tracking\Helper\Postdata $postdataHelper
    ) {
        $this->_trackingHelper = $trackingHelper;
        $this->_postdataHelper  = $postdataHelper;
    }

    /**
     * Registration observer
     *
     * @param \Magento\Framework\Event\Observer $observer
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        if (!$this->_trackingHelper->canTrackPages(self::CREATE_ACCOUNT)) {
            return false;
        }
        
        try {
            $customerData = $observer->getCustomer();
            $data = $this->_trackingHelper->getCustomerData($customerData, self::CREATE_ACCOUNT);
            $this->_postdataHelper->pushPages($data, self::CREATE_ACCOUNT);
         } catch (\Exception $e) {
            $this->_trackingHelper->debug("Account Register ERROR:" . $e->getMessage());
        }
    }
}
