<?php
namespace Targetbay\Tracking\Plugin\Order;

class Place {

	const ORDER_ITEMS = 'm2-ordered-items';

	protected $_trackingHelper;

	protected $_postdataHelper;

	protected $_state;

	public function __construct(\Targetbay\Tracking\Helper\Data $trackingHelper, \Targetbay\Tracking\Helper\Postdata $postdataHelper, \Magento\Framework\App\State $state) {
		$this -> _trackingHelper = $trackingHelper;
		$this -> _postdataHelper = $postdataHelper;
		$this -> _state = $state;
	}

	public function afterPlace($subject, $result) {
		if (!$this -> _trackingHelper -> canTrackPages(self::ORDER_ITEMS)) {
			return $result;
		}
		$areaCode = $this -> _state -> getAreaCode();
		if ($areaCode == 'adminhtml')
			return $result;
		try {
			$orderInfo = $this -> _trackingHelper -> getSessionInfo();
			$orderInfo['order_id'] = $result -> getId();
			$this -> _postdataHelper -> pushPages($orderInfo, self::ORDER_ITEMS);
		} catch (\Exception $e) {
			$this -> _trackingHelper -> debug(" Placed order  ERROR:" . $e -> getMessage());
		}
		return $result;
	}

}

