<?php
namespace Targetbay\Tracking\Plugin\Wishlist;

class Addtocart {

	const WISHLIST = 'wishlist';

	protected $_trackingHelper;

	protected $_postdataHelper;

	protected $_checkoutSession;

	public function __construct(\Targetbay\Tracking\Helper\Data $trackingHelper, \Targetbay\Tracking\Helper\Postdata $postdataHelper, \Magento\Checkout\Model\Session $checkoutSession) {
		$this -> _trackingHelper = $trackingHelper;
		$this -> _postdataHelper = $postdataHelper;
		$this -> _checkoutSession = $checkoutSession;

	}

	public function afterAddToCart(\Magento\Wishlist\Model\Item $subject, $result) {
		if (!$result)
			return $result;

		if (!$this -> _trackingHelper -> canTrackPages(self::WISHLIST))
			return $result;

		try {
			$item = $this -> _checkoutSession -> getQuote() -> getItemByProduct($subject -> getProduct());
			$data = array_merge($this -> _trackingHelper -> getCartInfo(), $this -> _trackingHelper -> getItemInfo($item, \Targetbay\Tracking\Observer\AddCartEventHandler::ADD_TO_CART, $item -> getQty()));
			$data['price'] = $item -> getProduct() -> getFinalPrice();
			if ($customOptions = $this -> _trackingHelper -> getCustomOptionsInfo($item, null)) {
				$data['attributes'] = $customOptions;
			}
			$this -> _postdataHelper -> pushPages($data, \Targetbay\Tracking\Observer\AddCartEventHandler::ADD_TO_CART);
		} catch(\Exception $e) {
			$this -> _trackingHelper -> debug("WISHLIST ADDTOCART ERROR:" . $e -> getMessage());
		}
		return $result;
	}

}
